#include 	<avr/io.h>
#include 	<stdio.h>
#include 	<util/delay.h>
#include	<avr/interrupt.h>
#include 	"lcd_h.h"
#include 	"twi_lib.h"

#define 	F_CPU 16000000UL	//definovn frekvence osciltoru
#define		RTC 0xA0			//adresa obvodu RTC
#define		setiny 0x01		//adresa registru setiny
#define		sekundy 0x02		//adresa registru sekundy
#define		minuty 0x03			//adresa registru minut
#define		hodiny 0x04			//adresa registru hodin
#define		dny 0x05			//adresa registru dny
#define		mesic 0x06			//adresa registru mesice

char 	buff[16];
unsigned char 	BCD;
int	 tl=17;						// Hodnota 17 sygnalizuje, e nen stisknuto dn tlatko
int  mod=0;						// Nastaven vchozho mdu
int  zpozdeni=1000;				// Zpodn po stisku tlatka

int sec_l=0;
int sec_h=0;
int min_l=0;
int min_h=0;
int hod_l=0;
int hod_h=0;
int den_l=0;
int den_h=0;
int mes_l=0;
int mes_h=0;


unsigned char read(bunka)
{
  i2c_start_wait(RTC+I2C_WRITE);		// Vysln start bitu, adresy RTC a bitu pro zpis (ten, zpis) (S ADR R/\W)
  i2c_write(bunka);						// Vysln datov adresy ze kter se m st
  i2c_rep_start(RTC+I2C_READ);   		// Vysln znovu start bitu, adresy RTC a bitu pro ten (ten, zpis) (S ADR R/\W)
  BCD = i2c_readNak();               	// Peten celho bytu z vyslan adresy (sekund)
  i2c_stop();                         	// Vysln Stop bitu, ukonen komunikace
}

unsigned char write(BCD,bunka)
{	
	i2c_start_wait(RTC+I2C_WRITE);   	// Vysln start bitu, adresy RTC a bitu pro zpis (ten, zpis) (S ADR R/\W)								   	
    i2c_write(bunka);					// vyber adresy(hodiny minuty atd)											   
	i2c_write(BCD);						// zapise BCD na vybranou adresu							   
	i2c_stop(); 						// Vysln Stop bitu, ukonen komunikace
}

int klavesnice(void)					// Funkce pro ten z klvesnice
{
  int i=0;
  int j=0;

  for(i=0;i<4;i++)						
  {
  	if(i==0)
	  PORTB = 0b11110111;				// Sepnut prvnho sloupce tlatek
	if(i==1)
	  PORTB = 0b11111011;				// Sepnut druhho sloupce tlatek
	if(i==2)
	  PORTB = 0b11111101;				// Sepnut tetho sloupce tlatek
	if(i==3)
	  PORTB = 0b11111110;				// Sepnut tvrtho sloupce tlatek

	for(j=0;j<4;j++)
  	{
	  if((bit_is_clear(PINB,PINB7)) && (i==0))		// ten stavu tlatka 1
	    tl=1;
	  if((bit_is_clear(PINB,PINB6)) && (i==0))		// ten stavu tlatka 2
	    tl=2;
	  if((bit_is_clear(PINB,PINB5)) && (i==0))		// ten stavu tlatka 3
	    tl=3;
	  if((bit_is_clear(PINB,PINB4)) && (i==0))		// ten stavu tlatka A
	    tl=10;

	  if((bit_is_clear(PINB,PINB7)) && (i==1))		// ten stavu tlatka 4
	    tl=4;
	  if((bit_is_clear(PINB,PINB6)) && (i==1))		// ten stavu tlatka 5
	    tl=5;
	  if((bit_is_clear(PINB,PINB5)) && (i==1))		// ten stavu tlatka 6
	    tl=6;
	  if((bit_is_clear(PINB,PINB4)) && (i==1))		// ten stavu tlatka B
	    tl=11;

	  if((bit_is_clear(PINB,PINB7)) && (i==2))		// ten stavu tlatka 7
	    tl=7;
	  if((bit_is_clear(PINB,PINB6)) && (i==2))		// ten stavu tlatka 8
	    tl=8;
	  if((bit_is_clear(PINB,PINB5)) && (i==2))		// ten stavu tlatka 9
	    tl=9;
	  if((bit_is_clear(PINB,PINB4)) && (i==2))		// ten stavu tlatka C
	    tl=12;

	  if((bit_is_clear(PINB,PINB7)) && (i==3))		// ten stavu tlatka *
	    tl=14;
	  if((bit_is_clear(PINB,PINB6)) && (i==3))		// ten stavu tlatka 0
	    tl=0;
	  if((bit_is_clear(PINB,PINB5)) && (i==3))		// ten stavu tlatka #
	    tl=15;
	  if((bit_is_clear(PINB,PINB4)) && (i==3))		// ten stavu tlatka D
	    tl=13;
	}	
  }
}

void set_cas(void)					// Funkce pro nastaven asu
{
  int set_sec_h=0;
  int set_sec_l=0;
  int set_min_h=0;
  int set_min_l=0;
  int set_hod_h=0;
  int set_hod_l=0;
  int poz=0;
  tl=17;
  mod=3;							// Md pro nastaven asu
  _delay_ms(zpozdeni);				// Zpodn po stisku tlatka
  lcd_clrscr();						// Mazn displaje

  lcd_gotoxy(0,0);					// Zpis na display
  lcd_puts("nastav cas");
  lcd_gotoxy(0,1);
  sprintf(buff,"poz:%d  %d%d:%d%d:%d%d",(poz+1),set_hod_h,set_hod_l,set_min_h,set_min_l,set_sec_h,set_sec_l);		
  lcd_puts(buff);
  lcd_gotoxy(0,2);				
  lcd_puts("A-potvr");
  lcd_gotoxy(0,3);				
  lcd_puts("D-jdi pryc");

  while(mod==3)
  {
  	klavesnice();					// ten z klvesnice
	_delay_ms(zpozdeni);			// Zpoden po stissku tlatka

	if(tl<10)						// Pokud je stisknuto tlatko 0 a 9 dojde k nastaven hodnoty
	{
	  if(poz==0)
		set_hod_h=tl;				// Nastaven destek hodin
	  if(poz==1)
		set_hod_l=tl;				// Nastaven jednotek hodin
	  if(poz==2)
		set_min_h=tl;				// Nastaven destek minut
	  if(poz==3)
		set_min_l=tl;				// Nastaven jednotek minut
	  if(poz==4)
		set_sec_h=tl;				// Nastaven destek sekund
	  if(poz==5)
		set_sec_l=tl;				// Nastaven jednotek sekund
	  tl=17;						// Signalizuje e neni stisknuto dn tlatko
	  poz=poz+1;					// Inkrementace pozice pro zpis
	}

	lcd_gotoxy(0,0);				// Vpis na display
  	lcd_puts("nastav cas");
	lcd_gotoxy(0,1);
	sprintf(buff,"poz:%d  %d%d:%d%d:%d%d",(poz+1),set_hod_h,set_hod_l,set_min_h,set_min_l,set_sec_h,set_sec_l);	
	lcd_puts(buff);

	if(tl==10)						// Pokud je stisknuto tlatko A dojde k potvrzen asu a odesln do obvodu RTC
    {
	  BCD = (((set_hod_h <<4) & 0xF0) | (set_hod_l & 0x0F));		// Peveden z binrnho vyjden na BDC
	  write(BCD,hodiny);											// Zpis hodin do obvodu RTC
	  BCD = (((set_min_h <<4) & 0xF0) | (set_min_l & 0x0F));		// Peveden z binrnho vyjden na BDC
	  write(BCD,minuty);											// Zpis minut do obvodu RTC
	  BCD = (((set_sec_h <<4) & 0xF0) | (set_sec_l & 0x0F));		// Peveden z binrnho vyjden na BDC
	  write(BCD,sekundy);											// Zpis sekund do obvodu RTC
	  mod=1;						// Nastaven vchozho mdu mdu
	  tl=17;						// Signalizuje e neni stisknuto dn tlatko
	  _delay_ms(zpozdeni);			// Zpodn po stisku tlatka

	  lcd_clrscr();
	  lcd_gotoxy(0,0);				
	  lcd_puts("A-nastaveni casu");
	  lcd_gotoxy(0,1);				
	  lcd_puts("B-nast. datumu");
	  lcd_gotoxy(0,2);				
 	  lcd_puts("D-zpet");
	}
    
	if(tl==13)						// Pi stisku tlatka D dojde k nastaven vchozho mdu
	{
	  mod=1;
	  _delay_ms(zpozdeni);
	  tl=17;
	 
	  lcd_clrscr();					// Vpis na display
	  lcd_gotoxy(0,0);				
	  lcd_puts("A-nastaveni casu");
	  lcd_gotoxy(0,1);				
	  lcd_puts("B-nast. datumu");
	  lcd_gotoxy(0,2);				
 	  lcd_puts("D-zpet");

	}
  }

}


void set_datum(void)				// Funkce pro nastaven datumu
{
  int set_den_h=0;
  int set_den_l=0;
  int set_mes_h=0;
  int set_mes_l=0;
  int poz=0;
  tl=17;
  mod=4;							// Md pro nastaven datumu
  _delay_ms(zpozdeni);				// Zpodn po stisku tlatka
  lcd_clrscr();						// Mazn dysplaje
  lcd_gotoxy(0,0);					// Vpis na display
  lcd_puts("nastav datum");
  lcd_gotoxy(0,1);
  sprintf(buff,"poz:%d  %d%d.%d%d.",(poz+1),set_den_h,set_den_l,set_mes_h,set_mes_l);		
  lcd_puts(buff);
  lcd_gotoxy(0,2);				
  lcd_puts("A-potvr");
  lcd_gotoxy(0,3);				
  lcd_puts("D-jdi pryc");

  while(mod==4)
  {
  	klavesnice();					// ten klvesnice
	_delay_ms(zpozdeni);			// Zpodn po stisku tlatka
	if(tl<10)						// Pokud je stisknuto tlatko s sly, dojde k nastaven promnn
	{
	  if(poz==0)
		set_den_h=tl;				// Nastaven destek dn
	  if(poz==1)
		set_den_l=tl;				// Nastaven jednotek dn
	  if(poz==2)
		set_mes_h=tl;				// Nastaven destek msce
	  if(poz==3)
		set_mes_l=tl;				// Nastaven jednotek msce
	  tl=17;
	  poz=poz+1;					// Inkrementace pozice pro zpis
	}
	lcd_gotoxy(0,0);				// Vpis na display
  	lcd_puts("nastav datum");
  	lcd_gotoxy(0,1);
	sprintf(buff,"poz:%d  %d%d.%d%d.",(poz+1),set_den_h,set_den_l,set_mes_h,set_mes_l);
	lcd_puts(buff);

	if(tl==10)						// Pokud je stisknuto tlatko A dojde k odesln dat do RTC
    {
	  BCD = (((set_den_h <<4) & 0b00110000) | (set_den_l & 0x0F));		// Pevod dn z binrnho vyjden na BCD
	  write(BCD,dny);													// Zapsn dn do RTC
	  BCD = (((set_mes_h <<4) & 0b00010000) | (set_mes_l & 0x0F));		// Pevod msc z binrnho vyjden na BCD
	  write(BCD,mesic);													// Zapsn msc do RTC

	  mod=1;						// Nastaven vchozho mdu
	  tl=17;
	  _delay_ms(zpozdeni);			// Zpodn

	  lcd_clrscr();					// Vpis na display
	  lcd_gotoxy(0,0);				
	  lcd_puts("A-nastaveni casu");
	  lcd_gotoxy(0,1);				
	  lcd_puts("B-nast. datumu");
	  lcd_gotoxy(0,2);				
 	  lcd_puts("D-zpet");

	}
    
	if(tl==13)						// Pi stisku tlatka D dojde k nvratu do vchozho mdu
	{
	  mod=1;						// Nastaven vchozho mdu
	  tl=17;
	  _delay_ms(zpozdeni);			// Zpodn

	  lcd_clrscr();					// Vpis na display
	  lcd_gotoxy(0,0);				
	  lcd_puts("A-nastaveni casu");
	  lcd_gotoxy(0,1);				
	  lcd_puts("B-nast. datumu");
	  lcd_gotoxy(0,2);				
 	  lcd_puts("D-zpet");

	}
  }
}

void stopky(void)					// Funkce stopky
{
  int m;
  int ss_2=1;
  int ss=1;
  int ss_h=0;
  int ss_l=0;
  int s_h=1;
  int s_l=1;
  int m_h=1;
  int m_l=1;
  int poc=0;
  int i=0;  

  int stopky_mod=0;
  
  char mezicas_1[16];				// Pole pro uloen mezias 
  char mezicas_2[16];
  char mezicas_3[16];


  mod=2;							// Nastaven mdu pro stoky
  tl=17;
  _delay_ms(zpozdeni);				// Zpodn
  lcd_clrscr();						// Mazn displaje

  lcd_gotoxy(0,0);					// Vpis na display
  sprintf(buff,"cas:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);		
  lcd_puts(buff);

  lcd_gotoxy(0,1);
  sprintf(mezicas_1,"mez:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);
  lcd_puts(mezicas_1);

  lcd_gotoxy(0,2);
  sprintf(mezicas_2,"mez:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);
  lcd_puts(mezicas_2);
	  
  lcd_gotoxy(0,3);
  sprintf(mezicas_3,"mez:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);
  lcd_puts(mezicas_3);

  while(mod==2)
  {
	read(setiny);					// ten setin z RTC
 	ss_l = 0x0f & BCD;				// Ziskani jednotek setin z BCD
	ss_h = (BCD>>4) & 0x0f;			// Ziskani desitek setin z BCD
	klavesnice();	

	if(tl==10)						// Pi stisku tlatka A jsou sputny stopky
	  stopky_mod=1;
	if(tl==11)						// Pi stisku tlatka B jsou stopky zastaveny
	  stopky_mod=2;
	if(tl==12)						// Pi stisku tlatka C jsou stopky vynulovny
	  stopky_mod=3;
	if(tl==13)						// Pi stisku tlatka D dojde k nvratu do vchozho mdu
	{
	  lcd_clrscr();					// Mazn displaje
	  mod=0;
	}
	if(tl==15)						// Pi stisku tlatka * je zasnamenn mezias
	{
	  stopky_mod=4;
	  m=s_l;
	}

	if(i==0)						// Pi sputn mus bt zaznamenna aktuln hodnoty desetin
	{
	  ss=ss_h;
	  i=1;
	}

	if(stopky_mod==1 || stopky_mod==4)		// Pokud je aktivn reim pro stopky je inkrementovn as
	{
		if(ss!=ss_h)						// Pokud hodnota desetin z pedchozho kroku neni rovna aktuln hodnot, jsou inkrementovny desetiny
		  {ss=ss_h;							// Uloen aktuln hodnoty desetin, do promn pro desetiny z pedchozho kroku
		   ss_2=ss_2+1;}					// Inkrementace desetin sekundy

		if(ss_2>10)							// Pokud dojde k peteen desetin sekundy, jsou inkrementovny sekudny
  		{   ss_2=1;							// Vynulovn desetin
			s_l=s_l+1;}						// Inkrementace sekund

		if(s_l>10)							// Pokud dojde k peteen sekund, jsou inkrementovny destky sekudny
  		{   s_l=1;							// Vynulovn sekund
			s_h=s_h+1;}						// Inkrementace destek sekund

		if(s_h>6)							// Pokud dojde k peteen destek sekund, jsou inkrementovny minuty
  		{   s_h=1;							// Vynulovn destek sekund
			m_l=m_l+1;}						// Inkrementace minut

		if(m_l>10)							// Pokud dojde k peteen minut, jsou inkrementovny destky minut
  		{   m_l=1;							// Vynulovn minut
			m_h=m_h+1;}						// Inkrementace destek minut

		if(m_h>6)							// Pi peteen tae destek minut dojde k tn od asu 00:00:0
  			{   
			m_h=1;
			m_l=1;
			s_h=1;
			s_l=1;
			ss_2=1;
			}

 	 	lcd_gotoxy(0,0);					// Vpis na display
 	 	sprintf(buff,"cas:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);
 	 	lcd_puts(buff);
	}

	if(stopky_mod==4)						// Uloen mezias
	{
	  
	  tl=17;

	  strcpy(mezicas_3,mezicas_2);	  		// Rotovn mezias
	  strcpy(mezicas_2,mezicas_1);

	  lcd_gotoxy(0,1);						// Vpis na display
	  sprintf(mezicas_1,"mez:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);
	  lcd_puts(mezicas_1);

	  lcd_gotoxy(0,2);
	  lcd_puts(mezicas_2);
	  
	  lcd_gotoxy(0,3);
	  lcd_puts(mezicas_3);	  
	  
	  stopky_mod=1;  						// Nastaven mdu pro bh stopek
	}



	if(stopky_mod==3)						// Nulovn stopek
	{
		m_h=1;
		m_l=1;
		s_h=1;
		s_l=1;
		ss_2=1;

		i=0;		

		lcd_gotoxy(0,0);					// Vpis na display
  		sprintf(buff,"cas:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);
  		lcd_puts(buff);

  	    lcd_gotoxy(0,1);
		sprintf(mezicas_1,"mez:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);
  		lcd_puts(mezicas_1);

  		lcd_gotoxy(0,2);
  		sprintf(mezicas_2,"mez:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);
  		lcd_puts(mezicas_2);
	  
  		lcd_gotoxy(0,3);
  		sprintf(mezicas_3,"mez:  %d%d:%d%d:%d",m_h-1,m_l-1,s_h-1,s_l-1,ss_2-1);
  		lcd_puts(mezicas_3);
	}

  }
  lcd_clrscr();							// Mazn displaje
}


void set(void)							// Menu pro nastaven asu a datumu
{
  mod=1;
  tl=17;
  _delay_ms(zpozdeni);					// Zpodn
  lcd_clrscr();							// Mazn displaje

  lcd_gotoxy(0,0);						// Vpis na display
  lcd_puts("A-nastaveni casu");
  lcd_gotoxy(0,1);				
  lcd_puts("B-nast. datumu");
  lcd_gotoxy(0,2);				
  lcd_puts("D-zpet");


  while(mod==1)
  {
	klavesnice();						// ten klvesnice

  	if(tl==10)							// Pi stisku tlatka A je volna funkce pro nastaven asu
	  set_cas();
	
  	if(tl==11)							// Pi stisku tlatka B je voln funkce pro nasven datumu
	  set_datum();
	
	if(tl==13)							// Nvrat do vchozho mdu
	  {mod=0;
	  tl=17;}
  }
  lcd_clrscr();							// Mazn displaje
}


int main(void)
{	
  DDRA = 0b11111110;
  DDRB = 0b00001111;

  sei();						// Povoleni preruseni
  i2c_init();					// Iinicializace TWI
  lcd_init();					// Iinicializace LCD

  lcd_clrscr();					// Mazn displaje


  while(1)
  {
	read(sekundy);					// ten sekund
    sec_l = 0x0f & BCD;				// Pevod jednotek sekund z BCD
	sec_h = (BCD>>4) & 0x0f;		// Pevod destek sekund z BCD

	read(minuty);					// ten minut
    min_l = 0x0f & BCD;				// Pevod jednotek minut z BCD
	min_h = (BCD>>4) & 0x0f;		// Pevod destek minut z BCD
	
	read(hodiny);					// ten hodin
    hod_l = 0x0f & BCD;				// Pevod jednotek hodin z BCD
	hod_h = (BCD>>4) & 0x0f;		// Pevod destek hodin z BCD	
	
	read(dny);						// ten dn
    den_l = 0x0f & BCD;				// Pevod jednotek dn z BCD
	den_h = (BCD>>4) & 0x03;		// Pevod desitek dn z BCD

	read(mesic);					// ten msc
    mes_l = 0x0f & BCD;				// Pevod jednotek msc z BCD
	mes_h = (BCD>>4) & 0x01;		// Pevod desitek msc z BCD


	klavesnice();					// ten klvesnice

	if((mod==0) && (tl==10))		// Pokud je stisknuto tlatko A je volna fukce pro nastaven
		set();
	
	if((mod==0) && (tl==11))		// Pokud je stisknuto tlatko B je volna funkce stopky
		stopky();

	if(mod==1)						// Pokud je nastaven md 1 je volna fukce nastaven
		set();

	lcd_gotoxy(0,0);				// Vpis na display
	sprintf(buff,"cas %d%d:%d%d:%d%d",hod_h,hod_l,min_h,min_l,sec_h,sec_l);		
	lcd_puts(buff);	
	lcd_gotoxy(0,1);				
	sprintf(buff,"datum  %d%d.%d%d.",den_h,den_l,mes_h,mes_l);		
	lcd_puts(buff);
	lcd_gotoxy(0,2);				
	lcd_puts("A-nastaveni");
	lcd_gotoxy(0,3);				
	lcd_puts("B-stopky");
  }
}


